<!doctype html>
<html lang="en">
<head>
    <title>Set Up Bash Dotfiles</title>
    <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <meta http-equiv="Cache-Control" content="no-cache, no-store, must-revalidate"/>
  <link rel="shortcut icon" href="/assets/img/logo.png" type="image/png">
  <meta http-equiv="Pragma" content="no-cache"/>
  <meta http-equiv="Expires" content="0"/>
  <!-- link rel="shortcut icon" href="/assets/img/logo.png" type="image/png"-->
  <link rel="stylesheet" href="/assets/styles.css">
</head>
<body>
<header class=nav-bar>
  <nav>
    <div class=sidebar-button></div>
    <!--div id=bwtoggle></div-->
    <a class="homelink spy" href="/">r<span class=hideable>wx.gg</span></a>
    <div class="nav-right">
      <!-- div id=search-box></div -->
      <ul class=nav-links>
        <li class=nav-item><a class=nav-link href="/boost/">Boosts</a></li>
        <!--
        <li class=nav-item><a class=nav-link href="/how/">HowTos</a></li>
        <li class=nav-item><a class=nav-link href="/contrib/">Contribute</a></li>
        -->
        <li class=nav-item><a class="nav-link" href="https://gitlab.com/rwx.gg/README">GitLab</a></li>
        <li class=nav-item><a class="nav-link" href="https://www.youtube.com/rwxrob">YouTube</a></li>
        <li class=nav-item><a class="nav-link" href="https://discord.gg/9wydZXY">Discord</a></li>
        <li class=nav-item><a class="nav-link" href="https://twitch.tv/rwxrob">Twitch</a></li>
      </ul>
    </div>
  </nav>
</header>
<main id=top>
<div class=container>  <h1 id=title class=duck><a href="https://duckduckgo.com/lite?kae=t&q=Set Up Bash Dotfiles">Set Up Bash Dotfiles</a></h1>
  <h2 id=subtitle><code>.bashrc</code>, <code>.bash_profile</code>, <code>.bash_aliases</code></h2>
  <p>Check if you have a <code>~/.bashrc</code> file.</p>
  <pre class="sh"><code>ls ~/.bashrc</code></pre>
  <p>Now you need to decide to use <code>~/.bash_aliases</code> or <code>~/.bashrc</code>. The <code>.bash_aliases</code> is usually plenty and doesn’t interfere with what the system <em>thinks</em> you should use for <code>.bashrc</code>. In fact, sometimes you don’t even have permission to change it (as is the case with PicoCTF). However, sometimes changing the <code>.bashrc</code> gives you more control. Consider doing that later. You can always use the same <code>dotfiles/bashrc</code> file and put it into <code>~/.bash_aliases</code> if you are on a system that does not allow you to change it (again, like PicoCTF).</p>
  <p>Peek at <code>~/.bashrc</code> to See if <code>~/.bash_aliases</code> Sourced Change into your <code>dotfiles</code> project repo directory Make a <code>bash</code> directory Make a new <code>bashrc</code> file (no initial period) Create a symlink from ~/.bashrc to the bashrc</p>
  <pre class="sh"><code>ln -fs &quot;$PWD/bashrc&quot; &quot;$HOME/.bashrc&quot;</code></pre>
  <p>Confirm the creation of the symlink.</p>
  <pre class="sh"><code>file ~/.bashrc</code></pre>
  <h2 id="resetting-your-shell">Resetting Your Shell</h2>
  <p>Before we do much more it is important to know how to get your Bash configuration to reset. You could certainly close your terminal and reopen it, or log back in, but the fastest way is simply to use the <code>exec</code> command as follows:</p>
  <pre class="sh"><code>exec bash</code></pre>
  <div class="co-pwz">
  <p>Some people will wrongly tell you to just to <code>bash</code> without the <code>exec bash</code>. This creates subshells after subshells rather than replacing your existing running shell process with a brand new one.</p>
  </div>
  <p>This works even better if one of the first things in your <code>bashrc</code> file is a command to clear everything that was set before. Otherwise the new shell inherits all the environment from the previous shell and only changes those things that are new. This means that anything you have removed will still be there.</p>
  <p>To clear <em>everything</em> from the previous settings consider unsetting all your aliases.</p>
  <pre class="sh"><code>unalias -a</code></pre>
  <div class="co-pwz">
  <p>You cannot unset the previous environment variables and functions this way. Just remember you will need to <code>unset &lt;thing&gt;</code> when you make those changes otherwise they will be inherited by the <code>exec bash</code> shell.</p>
  </div>
  <p>Now you can start building the rest of your custom <code>bashrc</code> file.</p>
  <h2 id="adding-aliases">Adding Aliases</h2>
  <p>First off let’s add an alias.</p>
  <p>How about making an alias for <code>clear</code>.</p>
  <p>Open the <code>bashrc</code> file for editing.</p>
  <pre class="sh"><code>alias c=clear</code></pre>
  <div class="co-btw">
  <p>No quotes are needed because there are no spaces.</p>
  </div>
  <p>Now test it by resetting your shell.</p>
  <pre class="sh"><code>exec bash</code></pre>
  <p>How about we add an alias with spaces requiring quotes. We’ll use single quotes because they are easier to type.</p>
  <pre class="sh"><code>alias ll=&#39;ls -la&#39;</code></pre>
  <p>Now reset and test that one.</p>
  <p>Okay, looks like everything is working.</p>
  <p>You might want to take a moment and make a comment for the section about aliases so that you can find it fast later is it grows longer.</p>
  <p>Now for some more important stuff.</p>
  <pre class="sh"><code>set -o vi</code></pre>
  <p>Reset and test that your arrow keys still work. Vi mode means that you are effectively in <code>--INSERT--</code> mode when working with your history as if it were a big file, except you can only see one line. This is why your arrow keys work but not your <code>hjkl</code> navigation keys.</p>
  <p>You activate command mode by pressing <code>Esc</code> or the <code>Control-[</code> equivalent.</p>
  <p>Now can do anything to your history as if it were a large file you are working with in Vi command mode. This includes searching through your entire history with <code>/</code> and then finding the next occurrence with <code>n</code> or previous with <code>N</code>. Notice that <code>n</code> continuously wraps around with the search. This is <em>really</em> fast way to pull up complex lines from your history that you did weeks ago.</p>
  <div class="co-tip">
  <p>Vi mode is one of the most powerful, yet unknown shell configurations of all. Not understanding its existence or power is why uninformed people suggest stupid things like <a href="/advice/dont/controll/">using <code>Control-L</code> to clear the screen</a>.</p>
  <p>You don’t need to learn all the shell <code>history</code> related shell commands and keys if you learn Vi mode.</p>
  </div>
  <h2 id="configure-your-shell-command-history">Configure Your Shell Command History</h2>
  <p>Now is probably a good time to add more capacity to your history file, or remove it if you are on an ultra-secure system.</p>
  <p>Type <code>history</code> to get a sample of your history. You will probably have a hundreds of lines. Do it again and pipe the output to <code>less</code> if you want to see them all.</p>
  <div class="co-tip">
  <p>Now might be a good time alias <code>more</code> to <code>less-R</code>.</p>
  </div>
  <p>Your history is actually saved in a <code>~/.bash_history</code> file that you can reset at any time. Some people even preserve it in their <code>dotfiles</code> but that is probably not a good idea considering how much it changes.</p>
  <p>Let’s up the size of the history from the default of about 500.</p>
  <p>Commonly the following environment variables are set related to history:</p>
  <pre class="bash"><code>HISTCONTROL=ignoreboth  # don&#39;t save dups and starting with spaces
  HISTFILESIZE=10000      # how many lines to save</code></pre>
  <p>You can learn more about them by searching for them in the <a href="https://duck.com/lite?kae=t&amp;q=Bash%20manual%20page">Bash manual page</a>. There are many other settings related to history you can set.</p>
</main>
<footer>
  <p><a href="/copyright/" id=copyright>© 2020 Rob Muhlestein. Licensed under Creative Commons Attribution-ShareAlike.</a><br/>Does something seem to have changed? <a href="/changes/">Check the change log</a>.
  <br>See something wrong? <a class="nodecor" href="https://gitlab.com/rwx.gg/README/-/issues">Open a ticket</a>.
  </p>
</footer>
<script src="/assets/main.js"></script>
</body>
</html>